VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IteratorSubstitute"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public row_ As Long
Private data_ As Excel.Worksheet

Public Sub Init(target As Excel.Worksheet, Optional tRow& = FIRST_ROW)
  Set data_ = target
  row_ = tRow
End Sub

Public Function Increment(Optional inc& = 1)
  If row_ + inc > 0 Then _
    row_ = row_ + inc
End Function

Public Function IncrementCounter()
  Counter = Counter + 1
End Function

Public Function GoFirst()
  row_ = FIRST_ROW
End Function

Public Function GoLast()
  row_ = data_.Columns(S_MATCH_TARGET).Find(vbNullString, LookAt:=xlWhole).Row - 1
End Function

Public Function IsDone() As Boolean
  IsDone = data_.Cells(row_, S_MATCH_TARGET) = vbNullString
End Function

Public Function RemoveRow()
  Call data_.Rows(row_).Delete
End Function

'===== Propertiy Get =====
Public Property Get FindWhat() As String
  FindWhat = data_.Cells(row_, S_MATCH_TARGET)
End Property

Public Property Get Replacement() As String
  Replacement = data_.Cells(row_, S_MATCH_REPLACEMENT)
End Property

Public Property Get UseMorpho() As Boolean
  UseMorpho = data_.Cells(row_, S_MATCH_MORPHO) <> 0
End Property

Public Property Get Counter() As Long
  Counter = data_.Cells(row_, S_MATCH_COUNTER)
End Property

Public Property Get IsMultipleWords() As Boolean
  IsMultipleWords = True
  
  Dim sData$: sData = FindWhat
  Dim nChar&
  For nChar = 1 To VBA.Len(sData)
    Dim sChar$: sChar = VBA.Mid(sData, nChar, 1)
    If Not IsAlphaNumeric(sChar) Then _
      Exit Function
  Next nChar
  
  IsMultipleWords = False
End Property

' ==== Property Let ====
Public Property Let FindWhat(newVal$)
  data_.Cells(row_, S_MATCH_TARGET) = newVal
End Property

Public Property Let Replacement(newVal$)
  data_.Cells(row_, S_MATCH_REPLACEMENT) = newVal
End Property

Public Property Let Counter(newVal&)
  data_.Cells(row_, S_MATCH_COUNTER) = newVal
End Property
