Attribute VB_Name = "MainImpl"
Option Private Module
Option Explicit

Public Function ClearAll()
  Call AccessSources.Clear
  Call AccesSubstitutes.Clear
End Function

Public Function PromptFolderMask(iData As DB_Sources) As Boolean
  PromptFolderMask = False
  
  Dim sMask$: sMask = UserInteraction.PromptInput("  ", " ", sInitial:=iData.FileMask)
  If sMask = vbNullString Then _
    Exit Function
  Dim sFolder$: sFolder = UserInteraction.PromptFolder(iData.TargetFolder & "\")
  If sFolder = vbNullString Then _
    Exit Function
  
  iData.TargetFolder = sFolder
  iData.FileMask = sMask
   
  PromptFolderMask = True
End Function

Public Function PrepareOrdersOutput() As Excel.Workbook
  Dim iExcel As New API_XLWrapper: Call iExcel.SetApplication(ThisWorkbook.Application)
  Set PrepareOrdersOutput = iExcel.NewDocument(sTemplate:=TEMPLATES_PATH & "\" & TEMPLATE_ORDERS, bDefaultIfFail:=False)
End Function

Public Function PrepareFormatOutput() As Excel.Workbook
  Dim iExcel As New API_XLWrapper: Call iExcel.SetApplication(ThisWorkbook.Application)
  Set PrepareFormatOutput = iExcel.NewDocument()
  iExcel.Document.Sheets(1).Cells(1, 1) = "File"
  iExcel.Document.Sheets(1).Cells(1, 2) = "Data"
End Function
