Attribute VB_Name = "DataAccess"
Option Private Module
Option Explicit

Public Function AccesSubstitutes() As DB_Substitutes
  Static s_Substitutes As DB_Substitutes
  
  If s_Substitutes Is Nothing Then
    Set s_Substitutes = New DB_Substitutes
    Call s_Substitutes.Init(ThisWorkbook.Worksheets(SHEET_SUBSTITUTES))
  End If
  
  Set AccesSubstitutes = s_Substitutes
End Function

Public Function AccessSources() As DB_Sources
  Static s_Sources As DB_Sources
  
  If s_Sources Is Nothing Then
    Set s_Sources = New DB_Sources
    Call s_Sources.Init(ThisWorkbook.Worksheets(SHEET_SOURCES))
  End If
  
  Set AccessSources = s_Sources
End Function
