Attribute VB_Name = "DevHelper"
Option Private Module
Option Explicit

Public Const TEST_TARGET_FOLDER = "testFiles"

Public Function Dev_PrepareSkeleton()
  ' Do nothing
End Function

Public Function Dev_ManualRunTest()
  Dim sSuite$: sSuite = "s_DBSources"
  Dim sTest$: sTest = "t_Clear"
  Dim sMsg$: sMsg = Dev_RunTestDebug(sSuite, sTest)
  Debug.Print sMsg
  Call MsgBox(sMsg)
End Function

Public Function Dev_GetTestSuite(sName$) As Object
  Select Case sName
  Case "s_DBSources": Set Dev_GetTestSuite = New s_DBSources
  End Select
End Function

Public Function TestFilesFolder() As String
  Dim fso As New Scripting.FileSystemObject
  TestFilesFolder = fso.GetParentFolderName(ThisWorkbook.Path) & "\" & TEST_TARGET_FOLDER
End Function

Public Function SetupTestFolder() As String
  Dim fso As New Scripting.FileSystemObject
  Dim sFolder$: sFolder = fso.GetParentFolderName(ThisWorkbook.Path) & "\" & TEST_TARGET_FOLDER
  If Not fso.FolderExists(sFolder) Then _
    Call fso.CreateFolder(sFolder)
  SetupTestFolder = sFolder
End Function
