VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "s_DBSources"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' TODO:
' Public Function LoadSourcesFrom(sFolder$, sMask$) As Long

Private db_ As DB_Sources
Private fso_ As Scripting.FileSystemObject
Private folder_ As String

Public Function Setup()
  ' Mandatory setup function
  Set db_ = AccessSources
  Set fso_ = New Scripting.FileSystemObject
  folder_ = SetupTestFolder
End Function

Public Function Teardown()
  ' Mandatory teardown function
  Call db_.Clear
  Call fso_.DeleteFolder(TestFilesFolder)
End Function

Public Function t_Clear()
  On Error GoTo PROPAGATE_ERROR
  
  Dim iter As IteratorSource: Set iter = db_.INew
  iter.Counter = 1
  iter.FileName = "test.txt"
  Call Dev_ExpectEQ(1, iter.Counter)
  Call Dev_ExpectEQ("test.txt", iter.FileName)
  
  Call Dev_NewCase("ClearCounters")
  Call db_.ClearCounters
  Call Dev_ExpectEQ(0, iter.Counter)
  Call Dev_ExpectEQ("test.txt", iter.FileName)
  
  Call Dev_NewCase("ClearAll")
  Call db_.Clear
  Call Dev_ExpectEQ("", iter.FileName)

  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function
